{
  URL Redirection -- ۰}{

  @ : ErnestLiou 2004
   : ΨӶiPADSLDNS.org}
   : Version 1.0.00
}
unit MainForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, CoolTrayIcon, jpeg, ExtCtrls, IdIntercept, IdLogBase,
  IdLogEvent, IdCookieManager, IdAntiFreezeBase, IdAntiFreeze,
  IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient, IdHTTP,
  StdCtrls, Mask, Buttons, Inifiles, ShellAPI, ComCtrls, ToolWin, ImgList,
  IdRawBase, IdRawClient, IdIcmpClient;

type
  TMainFormf = class(TForm)
    TrayIconMaster: TCoolTrayIcon;
    PopupMenuTray: TPopupMenu;
    ShowWindow: TMenuItem;
    HideWindow: TMenuItem;
    N1: TMenuItem;
    N3: TMenuItem;
    N2: TMenuItem;
    ProgExit: TMenuItem;
    ImageMain: TImage;
    IdHTTPMaster: TIdHTTP;
    IdAntiFreeze: TIdAntiFreeze;
    EditRemoteServer: TEdit;
    TimerMaster: TTimer;
    TimerHide: TTimer;
    PageControlMaster: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Label1: TLabel;
    Label2: TLabel;
    Label6: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    EditHostName: TEdit;
    EditPassword: TEdit;
    EditEMail: TEdit;
    BtnRefresh: TBitBtn;
    EditRefreshTime: TMaskEdit;
    BtnClose: TBitBtn;
    BtnSAVEData: TBitBtn;
    ImageListMaster: TImageList;
    ImageListLog: TImageList;
    ToolBar3: TToolBar;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ListBoxMemo: TListBox;
    GroupBoxStatus: TGroupBox;
    LabelStatusTitle: TLabel;
    LabelIPTitle: TLabel;
    LabelIP: TLabel;
    LabelStatus: TLabel;
    LabelMessageTitle: TLabel;
    LabelMessage: TLabel;
    ICMP: TIdIcmpClient;
    procedure BtnCloseClick(Sender: TObject);
    procedure ProgExitClick(Sender: TObject);
    procedure EditRemoteServerExit(Sender: TObject);
    procedure BtnRefreshClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BtnSAVEDataClick(Sender: TObject);
    procedure TimerMasterTimer(Sender: TObject);
    procedure ShowWindowClick(Sender: TObject);
    procedure HideWindowClick(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure TimerHideTimer(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ToolButton7Click(Sender: TObject);
    procedure ToolButton6Click(Sender: TObject);
  private
    { Private declarations }
    fs_APPath : String;
    function GetINIKeyData(as_APPath, as_ININame, as_Section, as_KeyName : String) : String;
    function lf_PingRemoteHost(as_RemoteHost : String) : Boolean;
    procedure lp_RefreshMesg;
    procedure lp_RefreshURLData;
    procedure lp_WriteLog(as_TXT, as_APPath, as_LogFile : String; var ao_ListBox : TListBox);
    procedure SetINIKeyData(as_APPath, as_ININame, as_Section, as_KeyName, as_KeyData : String);
    procedure SaveToLogFile(as_FilePath, as_FileName : String);
    procedure lp_ReloadINIData;
  public
    { Public declarations }
  end;

const

  CRLF = #13#10;

  cs_Title : String = 'URL Redirection';

  cs_Mesg0 : String = 'SERVERݩκoͰD';
  cs_Mesg1 : String = '令\';
  cs_Mesg2 : String = 'JEMAIL';
  cs_Mesg3 : String = 'JKX';
  cs_Mesg4 : String = 'JHOSTNAME';
  cs_Mesg5 : String = 'EMAIL榡X';
  cs_Mesg6 : String = 'HOSTNAME榡X';
  cs_Mesg7 : String = 'b|U';
  cs_Mesg8 : String = 'KX~';
  cs_Mesg9 : String = '|OܰʺAIP DNSA';
  cs_MesgA : String = 'IP Sܰ,s(Check SQL)';
  cs_MesgT : String = 'IP Sܰ,s(Check DNS)';

  cs_RefreshManual : String = 'ʧs';
  cs_RefreshAuto : String = '۰ʧs';
  cs_Connected : String = 'wsu';
  cs_DisConnected : String = 'su';
  cs_NoIP : String = '0.0.0.0';

  cs_DefaultURL : String = 'http://www.adsldns.org:8080/clientupdate.php?';

  cs_EqualSign : String = '=';
  cs_AndSign : String = '&';

  cs_Email : String = 'email';
  cs_Password : String = 'passwd';
  cs_HostName : String = 'hostname';
  cs_RefreshTime : String = 'RefreshTime';
  cs_RemoteHost : String = 'RemoteHost';
  cs_LogFileLines : String = 'LogFileLines';

  cs_INIFile : String = 'URLUpdate.ini';
  cs_LogFile : String = 'URLUpdate.log';

  cs_INISection0 : String = 'MainData';

var
  MainFormf: TMainFormf;

implementation

{$R *.dfm}

procedure TMainFormf.BtnCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TMainFormf.ProgExitClick(Sender: TObject);
begin
  BtnCloseClick(nil);
end;

procedure TMainFormf.EditRemoteServerExit(Sender: TObject);
begin
  EditRemoteServer.Width := Length(EditRemoteServer.Text) * 7;
  EditRemoteServer.Left := ImageMain.Width - EditRemoteServer.Width;
end;

procedure TMainFormf.lp_RefreshURLData;
var
  ls_Request : String;
  ls_URLStr, ls_MesgCode, ls_IPAddress : String;
begin

  Screen.Cursor := crHourGlass;

  BtnRefresh.Enabled := False;

  IdHTTPMaster.DisconnectSocket;

  try
    IdHTTPMaster.Request.Username    := '';
    IdHTTPMaster.Request.Password    := '';
    IdHTTPMaster.Request.ContentType := '';

    ls_URLStr := cs_DefaultURL +
                 cs_Email + cs_EqualSign + Trim(EditEMail.Text) + cs_AndSign +
                 cs_Password + cs_EqualSign + Trim(EditPassword.Text) + cs_AndSign +
                 cs_HostName + cs_EqualSign + Trim(EditHostName.Text);

    ls_Request := Trim(IdHTTPMaster.Get(ls_URLStr));

    ls_MesgCode  := Copy(ls_Request,1,1);
    ls_IPAddress := Trim(Copy(ls_Request,POS(' ', ls_Request) + 1, 16));
    LabelIP.Caption := ls_IPAddress;

    try
      if (ls_MesgCode = 'A') then begin
        lp_WriteLog(ls_IPAddress + '; ' + cs_MesgA, fs_APPath, cs_LogFile, ListBoxMemo);
        LabelMessage.Caption := cs_MesgA;
      end else if (ls_MesgCode = 'T') then begin
        lp_WriteLog(ls_IPAddress + '; ' + cs_MesgT, fs_APPath, cs_LogFile, ListBoxMemo);
        LabelMessage.Caption := cs_MesgT;
      end else begin
        case StrToInt(ls_MesgCode) of
          0 : begin
                lp_WriteLog(ls_IPAddress + '; ' + cs_Mesg0, fs_APPath, cs_LogFile, ListBoxMemo);
                LabelMessage.Caption := cs_Mesg0;
              end;
          1 : begin
                lp_WriteLog(ls_IPAddress + '; ' + cs_Mesg1, fs_APPath, cs_LogFile, ListBoxMemo);
                LabelMessage.Caption := cs_Mesg1;
              end;
          2 : begin
                lp_WriteLog(ls_IPAddress + '; ' + cs_Mesg2, fs_APPath, cs_LogFile, ListBoxMemo);
                LabelMessage.Caption := cs_Mesg2;
              end;
          3 : begin
                lp_WriteLog(ls_IPAddress + '; ' + cs_Mesg3, fs_APPath, cs_LogFile, ListBoxMemo);
                LabelMessage.Caption := cs_Mesg3;
              end;
          4 : begin
                lp_WriteLog(ls_IPAddress + '; ' + cs_Mesg4, fs_APPath, cs_LogFile, ListBoxMemo);
                LabelMessage.Caption := cs_Mesg4;
              end;
          5 : begin
                lp_WriteLog(ls_IPAddress + '; ' + cs_Mesg5, fs_APPath, cs_LogFile, ListBoxMemo);
                LabelMessage.Caption := cs_Mesg5;
              end;
          6 : begin
                lp_WriteLog(ls_IPAddress + '; ' + cs_Mesg6, fs_APPath, cs_LogFile, ListBoxMemo);
                LabelMessage.Caption := cs_Mesg6;
              end;
          7 : begin
                lp_WriteLog(ls_IPAddress + '; ' + cs_Mesg7, fs_APPath, cs_LogFile, ListBoxMemo);
                LabelMessage.Caption := cs_Mesg7;
              end;
          8 : begin
                lp_WriteLog(ls_IPAddress + '; ' + cs_Mesg8, fs_APPath, cs_LogFile, ListBoxMemo);
                LabelMessage.Caption := cs_Mesg8;
              end;
          9 : begin
                lp_WriteLog(ls_IPAddress + '; ' + cs_Mesg9, fs_APPath, cs_LogFile, ListBoxMemo);
                LabelMessage.Caption := cs_Mesg9;
              end;
        end;
      end;
     finally
        SaveToLogFile(fs_APPath, cs_LogFile);
     end;
  finally
    IdHTTPMaster.DisconnectSocket;
    Screen.Cursor := crDefault;
    BtnRefresh.Enabled := True;
  end;

end;

procedure TMainFormf.lp_WriteLog(as_TXT, as_APPath, as_LogFile : String; var ao_ListBox : TListBox);
var
  ls_TempStrings : TStringList;
begin

  try
    ls_TempStrings := TStringList.Create;
    ls_TempStrings.Clear;

    try
      ls_TempStrings.LoadFromFile(as_APPath + as_LogFile);
    except
      ls_TempStrings.Clear;
    end;  

    ls_TempStrings.Append(DateTimeToStr(Now) + ' - ' + as_TXT);

    ao_ListBox.Items.Clear;
    ao_ListBox.Items.AddStrings(ls_TempStrings);

  finally
    FreeAndNil(ls_TempStrings);
  end;

end;

procedure TMainFormf.BtnRefreshClick(Sender: TObject);
begin
  if lf_PingRemoteHost(EditRemoteServer.Text) then begin
    lp_WriteLog(cs_RefreshManual, fs_APPath, cs_LogFile, ListBoxMemo);
    SaveToLogFile(fs_APPath, cs_LogFile);
    lp_RefreshURLData;
    LabelStatus.Caption := cs_Connected;
    lp_RefreshMesg;
  end else begin
    lp_WriteLog(cs_Mesg0, fs_APPath, cs_LogFile, ListBoxMemo);
    SaveToLogFile(fs_APPath, cs_LogFile);
    LabelStatus.Caption := cs_DisConnected;
    LabelIP.Caption := cs_NoIP;
    LabelMessage.Caption := cs_Mesg0;
    lp_RefreshMesg;
  end;
end;

procedure TMainFormf.TimerMasterTimer(Sender: TObject);
begin
  if lf_PingRemoteHost(EditRemoteServer.Text) then begin
    lp_WriteLog(cs_RefreshAuto, fs_APPath, cs_LogFile, ListBoxMemo);
    SaveToLogFile(fs_APPath, cs_LogFile);
    lp_RefreshURLData;
    LabelStatus.Caption := cs_Connected;
    lp_RefreshMesg;
  end else begin
    lp_WriteLog(cs_Mesg0, fs_APPath, cs_LogFile, ListBoxMemo);
    SaveToLogFile(fs_APPath, cs_LogFile);
    LabelStatus.Caption := cs_DisConnected;
    LabelIP.Caption := cs_NoIP;
    LabelMessage.Caption := cs_Mesg0;
    lp_RefreshMesg;
  end;
end;

procedure TMainFormf.FormCreate(Sender: TObject);
begin

  //oε{Ҧb|
  fs_APPath := ExtractFilePath(Application.ExeName);

  PageControlMaster.ActivePage := TabSheet1;

  lp_ReloadINIData;

  //ҰʮɶiĤ@s
  TimerMasterTimer(nil);
  
end;

//oINIY@KeyData
function TMainFormf.GetINIKeyData(as_APPath, as_ININame, as_Section, as_KeyName : String) : String;
var
  inifile : TIniFile;
begin

  Result := '';

  try
    inifile := TIniFile.Create(as_APPath + as_ININame);

    if inifile <> nil then begin
      Result := inifile.ReadString(as_Section, as_KeyName, '');
    end;
  finally
    FreeAndNil(inifile);
  end;

end;

//xsINI File
procedure TMainFormf.SetINIKeyData(as_APPath, as_ININame, as_Section, as_KeyName, as_KeyData : String);
var
  inifile : TIniFile;
begin

  try
    inifile := TIniFile.Create(as_APPath + as_ININame);
    if inifile <> nil then begin
      with inifile do begin
        WriteString(as_Section, as_KeyName, as_KeyData);
      end;
      try
        inifile.UpdateFile;
      except;
      end;
    end;
  finally
    FreeAndNil(inifile);
  end;

end;

procedure TMainFormf.BtnSAVEDataClick(Sender: TObject);
begin

  SetINIKeyData(fs_APPath, cs_INIFile, cs_INISection0, cs_Email, EditEMail.Text);
  SetINIKeyData(fs_APPath, cs_INIFile, cs_INISection0, cs_Password, EditPassword.Text);
  SetINIKeyData(fs_APPath, cs_INIFile, cs_INISection0, cs_HostName, EditHostName.Text);
  SetINIKeyData(fs_APPath, cs_INIFile, cs_INISection0, cs_RefreshTime, EditRefreshTime.Text);
  SetINIKeyData(fs_APPath, cs_INIFile, cs_INISection0, cs_RemoteHost, EditRemoteServer.Text);

  lp_ReloadINIData;

end;

procedure TMainFormf.ShowWindowClick(Sender: TObject);
begin
  TimerMaster.Enabled := False;
  TrayIconMaster.ShowMainForm;
end;

procedure TMainFormf.HideWindowClick(Sender: TObject);
begin
  TimerMaster.Enabled := True;
  Application.Minimize;
  TrayIconMaster.HideMainForm;
end;

procedure TMainFormf.N3Click(Sender: TObject);
begin
  ShellExecute(Handle, 'open', PChar(fs_APPath + cs_LogFile), nil, nil, SW_SHOW);
end;

procedure TMainFormf.TimerHideTimer(Sender: TObject);
begin
  HideWindowClick(nil);
  TimerHide.Enabled := False;
end;

procedure TMainFormf.FormDestroy(Sender: TObject);
begin
  SaveToLogFile(fs_APPath, cs_LogFile);
end;

procedure TMainFormf.SaveToLogFile(as_FilePath, as_FileName : String);
var
  ls_TempStrings, ls_LogFile : TStringList;
  li_Index, li_RecCount, li_RecIndex : Integer;
  li_LogFileLines : Integer;
begin

  try

    ls_TempStrings := TStringList.Create;
    ls_LogFile := TStringList.Create;
    ls_TempStrings.Clear;
    ls_LogFile.Clear;
    li_RecCount := 0;
    li_RecIndex := 0;

    //o]wɤ̤jƳ]w
    li_LogFileLines := StrToInt(GetINIKeyData(fs_APPath, cs_INIFile, cs_INISection0, cs_LogFileLines));

    try
      ls_TempStrings.AddStrings(ListBoxMemo.Items);

      for li_Index := (ls_TempStrings.Count - 1) downto 0 do begin
        if li_RecCount >= li_LogFileLines then begin
          li_RecIndex := li_Index;
          Break;
        end;
        Inc(li_RecCount);
      end;

      for li_Index := li_RecIndex to ls_TempStrings.Count - 1 do begin
        ls_LogFile.Append(ls_TempStrings.Strings[li_Index]);
      end;

      ls_LogFile.SaveToFile(as_FilePath + as_FileName);
    except
    end;
  finally
    FreeAndNil(ls_LogFile);
    FreeAndNil(ls_TempStrings);
  end;
  
end;

procedure TMainFormf.ToolButton7Click(Sender: TObject);
begin
  ListBoxMemo.Items.Clear;
end;

procedure TMainFormf.ToolButton6Click(Sender: TObject);
begin
  SaveToLogFile(fs_APPath, cs_LogFile);
end;

procedure TMainFormf.lp_ReloadINIData;
var
  li_UpdateInterval : Integer;
  ls_UpdateInterval : String;
begin
  EditEMail.Text       := GetINIKeyData(fs_APPath, cs_INIFile, cs_INISection0, cs_Email);
  EditPassword.Text    := GetINIKeyData(fs_APPath, cs_INIFile, cs_INISection0, cs_Password);
  EditHostName.Text    := GetINIKeyData(fs_APPath, cs_INIFile, cs_INISection0, cs_HostName);
  EditRefreshTime.Text := GetINIKeyData(fs_APPath, cs_INIFile, cs_INISection0, cs_RefreshTime);

  li_UpdateInterval := StrToInt(Trim(EditRefreshTime.Text));

  ls_UpdateInterval := IntToStr(li_UpdateInterval * 60 * 1000);

  with TimerMaster do begin
    Enabled  := False;
    Interval := StrToInt(ls_UpdateInterval);
    Enabled  := True;
  end;
end;

function TMainFormf.lf_PingRemoteHost(as_RemoteHost : String) : Boolean;
var
  ls_MsRoundTripTime : String;
begin

  ls_MsRoundTripTime := '0';

  with ICMP do begin
    Host := Trim(as_RemoteHost);
    ReceiveTimeOut := 1000;
    try
      Ping;
      ls_MsRoundTripTime := IntToStr(ICMP.ReplyStatus.MsRoundTripTime);
    except
    end;
  end;

  if ls_MsRoundTripTime = '0' then
    Result := False
  else
    Result := True;

end;

procedure TMainFormf.lp_RefreshMesg;
begin
  TrayIconMaster.Hint := cs_Title + CRLF +
                         LabelStatusTitle.Caption + LabelStatus.Caption + CRLF +
                         LabelIPTitle.Caption + LabelIP.Caption + CRLF +
                         LabelMessageTitle.Caption + LabelMessage.Caption;
end;

end.
